function map(array,callback){
  let arr = []
  for (let index = 0; index < array.length; index++) {
    const item = array[index];
    arr.push(callback(item,index))
  }
  return arr
}

function filter(array,callback){
  let arr = []
  for (let index = 0; index < array.length; index++) {
    const item = array[index];
    if(callback(item,index)){
      arr.push(item)
    }
  }
  return arr
}

function reduce(array,callback,pre){
  for (let index = 0; index < array.length; index++) {
    const item = array[index];
    pre = callback(pre,item,index)
  }
  return pre
}

function find(array,callback){
  for (let index = 0; index < array.length; index++) {
    const item = array[index];
    if(callback(item,index)){
      return item
    }
  }
}

function findIndex(array,callback){
  for (let index = 0; index < array.length; index++) {
    const item = array[index];
    if(callback(item,index)){
      return index
    }
  }
}

function some(array,callback){
  for (let index = 0; index < array.length; index++) {
    const item = array[index];
    if(callback(item,index)){
      return true
    }
  }
  return false
}

function every(array,callback){
  for (let index = 0; index < array.length; index++) {
    const item = array[index];
    if(!callback(item,index)){
      return false
    }
  }
  return true
}
export {map,filter,reduce,find,findIndex,some,every}