export default function axios({
  url,
  method="GET",
  data={},
  params={}
}){
  return new Promise((resolve,reject)=>{
    method = method.toUpperCase()
    let queryStr = ''
    Object.keys(params).forEach(key => {
      queryStr += `&${key}=${params[key]}`
    })
    url += '?' + queryStr.slice(1,queryStr.length)

    let xhr = new XMLHttpRequest()
    xhr.open(method,url,true)

    xhr.onreadystatechange = () => {
      let {readyState,response,error,status} = xhr
      if(readyState!==4)  return  // 请求还未完成
      if(status>=200&&status<300){
        let res = {
          response:JSON.parse(response),
          status
        }
        resolve(res)
      }else{
        reject(error)
      }
    }

    if(method==='PUT'||method==="POST"){
      xhr.setRequestHeader('Content-Type','application/json')
      // xhr.setRequestHeader('Content-Type','application/x-www-form-urlencoded')
      xhr.send(JSON.stringify(data))
    }else if(method==='GET'||method==="DELETE"){
      xhr.send()
    }
  })
}