export function debounce(fn,delay){
  // 返回一个新韩淑
  return function(event){
    // 判断当前对象自身是否有挂载定时器 有的话清除
    if(fn.hasOwnProperty('timer')){
      clearTimeout(fn.timer)
    }
    // 调用函数
    fn.timer = setTimeout(() => {
      fn.call(this,event)
      delete fn.timer
    }, delay);
  }
}