/* 1). 大众乞丐版
问题1: 函数属性会丢失
问题2: 循环引用会出错
2). 面试基础版本
解决问题1: 函数属性还没丢失
3). 面试加强版本
解决问题2: 循环引用正常
 */

// 函数属性会丢失
// 循环引用会出错
function deepClone1(object){
  return JSON.parse(JSON.stringify(object))
}

// 解决函数属性会丢失
function deepClone2(object){
  if((object !== null && typeof object == 'object') || object instanceof Array){
    let cloneObj = Array.isArray(object) ? [] : {}
    for (const key in object) {
      if (Object.hasOwnProperty.call(object, key)) {
        const value = object[key];
        cloneObj[key] = deepClone2(value) //递归调用
      }
    }
    return cloneObj
  }else {
    return object // 返回数据
  }
}


// 解决属性嵌套 会崩溃
function deepClone3(object,map = new Map()){
  if((object !== null && typeof object == 'object') || object instanceof Array){
    let cloneObj = map.get(object)
    if(cloneObj)  return cloneObj
    cloneObj = Array.isArray(object) ? [] : {}
    map.set(object,cloneObj)
    for (const key in object) {
      if (Object.hasOwnProperty.call(object, key)) {
        const value = object[key];
        cloneObj[key] = deepClone3(value,map) //递归调用
      }
    }
    return cloneObj
  }else {
    return object // 返回数据
  }
}
export {deepClone1,deepClone2,deepClone3}
