/* 语法: object mergeObject(...objs)
功能: 合并多个对象, 返回一个合并后对象(不改变原对象)
合并前:
    { a: [{ x: 2 }, { y: 4 }], b: 1}
    { a: { z: 3}, b: [2, 3], c: 'foo'}
合并后: 
    { a: [ { x: 2 }, { y: 4 }, { z: 3 } ], b: [ 1, 2, 3 ], c: 'foo' } */
import {concat} from '../array/concat.js'
export function mergeObject(...objs){
  let obj = {}
  objs.forEach(itemObj => {
    Object.keys(itemObj).forEach(key => {
      if(obj.hasOwnProperty(key)){
        obj[key] = concat([],obj[key],itemObj[key])
      }else{
        obj[key] = itemObj[key]
      }
    })
  })
  return obj
}