/* 
    1. 自定义new工具函数
        语法: newInstance(Fn, ...args)
        功能: 创建Fn构造函数的实例对象
        实现: 创建空对象obj, 调用Fn指定this为obj, 返回obj
    2. 自定义instanceof工具函数
        语法: myInstanceOf(obj, Type)
        功能: 判断obj是否是Type类型的实例
        实现: Type的原型对象是否是obj的原型链上的某个对象, 如果是返回tru, 否则返回false
*/
import {call} from '../function/call.js'
export function newInstanceOf(Fn,...args){
  let obj = {}
  call(Fn,obj,...args)
  return obj
}

export function myInstanceOf(obj, Type){
  let pro = obj.__proto__
  while(pro.__proto__ !== null){
    if(pro == Type.prototype){
      return true
    }
    // 保存下一个原型对象进入循环
    pro = pro.__proto__
  }
  return false
}