let PENDING = 'pending'
let RESOLVED = 'resolved'
let REJECTED = 'rejected'


function Promise(excutor){
  const self = this // 保存this
  self.status = PENDING // 默认状态属性
  self.data = undefined // 默认value
  self.callbacks = [] // 保存回调函数容器 {onResolved,onRejected}
  function resolve(value){
    if(self.status!==PENDING) return  // 如果不是pending直接return
    self.status === RESOLVED  // 改变状态
    self.data = value // 保存value
    setTimeout(() => {  // 异步调用resolved状态的回调函数
      self.callbacks.forEach(callbackObj => {
        callbackObj[onResolved](self.data) 
      });
    })
  }
  function reject(reason){
    if(self.status!==PENDING) return
    self.status === REJECTED
    self.data = reason
    setTimeout(() => {
      self.callbacks.forEach(callbackObj => {
        callbackObj[REJECTED](self.data) 
      });
    })
  }

  try {
    excutor(resolve,reject) // 同步执行构造器函数
  } catch (error) {
   reject(error) 
  }
}

Promise.prototype.then = function(onResolved,onRejected){
  const self = this
  onResolved = typeof onResolved  == 'function' ? onResolved : value => value // 将value向下传递
  onRejected = typeof onRejected  == 'function' ? onRejected : reason => {throw reason} // 将错误向下传递 
  return new Promise((resolve,reject) => {  // 返回新的promise
    function handleFun (callback){ // 定义统用函数
      try {
        const result = callback(self.data)
        if(result instanceof Promise){
          result.then(
            value => resolve(value),
            reason => reject(reason)
          )
        }
      } catch (error) {
        reject(error)
      }
    }

    if(self.status===RESOLVED){ // 如果当前promise对象状态为resolved 
      setTimeout(() => {
        handleFun(onResolved)
      });
    }else if(self.status===REJECTED){ // 如果当前promise对象状态为rejected
      setTimeout(() => {
        handleFun(onRejected)
      });
    }else{
      self.callbacks.push({ // 状态为pending保存回调函数
        onResolved(value){  
          handleFun(onResolved)
        },
        onRejected(value){
          handleFun(onResolved)
        }
      })
    }

    /* if(self.status===RESOLVED){ // 如果当前promise对象状态为resolved 
      setTimeout(() => {
        try { // 尝试捕获错误 有错误 直接reject
          const result = onResolved(self.data) // 直接调用onResolved函数
          if(result instanceof Promise){  // 判断结果是否为promise的实例
            result.then(  // 是promise的实例对象  当前这个promise的状态决定返回新的promise的状态
              value => resolve(value),
              reson => reject(reson)
            )
          }else{  // 不是promsie 直接调用resolve
            resolve(result)
          }
        } catch (error) {
          reject(error) 
        }
      });
    }else if(self.status===REJECTED){
      setTimeout(() => {
        try { // 尝试捕获错误 有错误 直接reject
          const result = onRejected(self.data) // 直接调用onRejected函数
          if(result instanceof Promise){  // 判断结果是否为promise的实例
            result.then(  // 是promise的实例对象  当前这个promise的状态决定返回新的promise的状态
              value => resolve(value),
              reson => reject(reson)
            )
          }else{  // 不是promsie 直接调用resolve
            resolve(result)
          }
        } catch (error) {
          reject(error) 
        }
      });
    }else{
      self.callbacks.push({ // 状态为pending保存回调函数
        onResolved(value){  
          try { // 尝试捕获错误 有错误 直接reject
            const result = onResolved(self.data) // 直接调用onResolved函数
            if(result instanceof Promise){  // 判断结果是否为promise的实例
              result.then(  // 是promise的实例对象  当前这个promise的状态决定返回新的promise的状态
                value => resolve(value),
                reson => reject(reson)
              )
            }else{  // 不是promsie 直接调用resolve
              resolve(result)
            }
          } catch (error) {
            reject(error) 
          }
        },
        onRejected(value){
          try { // 尝试捕获错误 有错误 直接reject
            const result = onRejected(self.data) // 直接调用onRejected函数
            if(result instanceof Promise){  // 判断结果是否为promise的实例
              result.then(  // 是promise的实例对象  当前这个promise的状态决定返回新的promise的状态
                value => resolve(value),
                reson => reject(reson)
              )
            }else{  // 不是promsie 直接调用resolve
              resolve(result)
            }
          } catch (error) {
            reject(error) 
          }
        }
      })
    } */
  })
}
// catch是then的语法糖格式
Promise.prototype.catch = function(onRejected){
  return this.then(undefined,onRejected)
}

/* 
用来返回一个指定vlaue的成功的promise
// value有可能是一个值也可以是一个promise
*/
Promise.resolve = function(value){
  return new Promise((resolve,reject)=> { //返回一个新的promise对象实例
    if(value instanceof Promise){ // 判断传值是否为promise 如果是
      value.then( // 通过value.then 有当前的promise的结果决定返回新的promise的状态
        val => {resolve(val)},
        reason => {reject(reason)},
      )
    }else{  // 如果不是promise的实例 直接调用resolve
      resolve(value)
    }
  })
}

// 用来返回一个指定reason的失败的promise
// reason只能是一个值 
Promise.reject = function(reason){
  return new Promise((resolve,reject)=> { //返回一个新的promise对象实例
    reject(reason)
  })
}

/* 
返回一个promise, 由第一个完成promise决定
*/
Promise.race = function(promises){
  return new Promise((resolve,reject)=> {
    promises.forEach(p => { // 遍历所有的promise数组
      p.then(
        value => resolve(value), // 最快的promise调用resolve或者reject
        reason => reject(reason),
      )
    })
  })
}

/* 
返回一个promise, 只有当数组中所有promise都成功才成功, 否则失败
*/
Promise.all = function(promises){
  let resolvedCount = 0 // 计数器已调用回调函数的promise的数量
  let values = [] // 保存value的数组
  return new Promise((resolve,reject)=> {
    promises.forEach((p,index) => {
      p.then(
        value => {
          resolvedCount++ // 每调用一次 数量＋1
          values[index] = value // 对应的index和指定value
          if(resolvedCount===promises.length){  // 如果已完成数量和传入all的数组长度一致调用resolve
            resolve(value)
          }
        },
        reason => reject(reason)
      )
    })
  })
}

export default Promise