let pubsub = {}

let id = 0 
let pubsubContainer = {}
pubsub.subScribe = function(msg,callback){
  let callbacks = pubsubContainer[msg]
  if(!callbacks){
    callbacks = {}
    pubsubContainer[msg] = callbacks
  }

  const token = 'uid_' + id++
  callbacks[token] = callback

  return token
}

pubsub.publish = function(msg,data){
  let callbacks = pubsubContainer[msg]
  if(!callbacks)  return 
  /* for (const key in callbacks) {
    if (Object.hasOwnProperty.call(object, key)) {
      const callback = callbacks[key];
      setTimeout(() => {
        callback(data)
      }, timeout);
    }
  } */
  Object.values(callbacks).forEach(callback => {
    setTimeout(() => {
      callback(data) 
    });
  })
}

pubsub.publishSync = function(msg,data){
  let callbacks = pubsubContainer[msg]
  if(!callbacks)  return 
  /* for (const key in callbacks) {
    if (Object.hasOwnProperty.call(object, key)) {
      const callback = callbacks[key];
      callback(data)
    }
  } */
  Object.values(callbacks).forEach(callback => {
    callback(data) 
  })
}


pubsub.off = function(msg){
  if(msg === null || msg === undefined) pubsubContainer = {}
  else if(msg.indexOf('uid_')==0){
    Object.keys(pubsubContainer).forEach(callbacks => {
      delete callbacks[msg]
    })
  }else {
    delete pubsubContainer[msg]
  }
}

export default pubsub