function Person(name,age){
  this.name = name;
  this.age = age
}

Person.prototype.sayName = function(){
  console.log(this.name);
}

function Student(name,age,sex){
  Person.call(this,name,age) // 自身属性得继承
  this.sex = sex
}

// 这样会导致 子类的原型对象添加name age属性 但是永远不会被访问到 
// 父类的方法多调用一次 子类构造器的丢失
// Student.prototype = new Person()


// 解决  定义一个空函数 空函数的原型指向父类的原型  子类的原型指向 空函数的实例
/* createFn.prototype = Person.prototype
Student.prototype = new createFn() */

function createFn(callback){
  function FN(){}
  FN.prototype = callback
  return new FN()
}
Student.prototype = new createFn(Person.prototype)
Student.prototype.construct = Student

export {createFn} 

